> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.createonetimepurchaseorder.md).

# IAP.createOneTimePurchaseOrder

### 功能说明

会跳转到单笔应用内支付订单页。支付·商品发放流程由 `options` / `onEvent` / `onError` 会以事件风格选项处理。

* `options.sku`: 是要下单的商品 ID。(`productId`已弃用)
* `options.processProductGrant`: 在订单创建后发放商品时调用。会将发放成功与否 `true`/`false`作为（或 Promise）返回。
* `onEvent`: 支付成功时 `type: 'success'`并携带结果数据调用。
* `onError`: 在支付过程中发生错误时调用。

返回值 cleanup 函数会在应用内支付功能结束后务必调用以释放资源。

Toss App Android/iOS `5.219.0` 及以上版本可使用。在不支持的版本中调用时 `UNSUPPORTED_APP_VERSION` 会发生错误。

### 类型

```ts
IAP.createOneTimePurchaseOrder(params: IapCreateOneTimePurchaseOrderOptions): () => void;
```

**参数**

```ts
interface IapCreateOneTimePurchaseOrderOptions {
  options: {
    sku: string;
    /** @deprecated 使用 sku */
    productId?: string;
    processProductGrant: (params: {
      orderId: string;
    }) => boolean | Promise<boolean>;
  };
  onEvent: (event: {
    type: "success";
    data: IapCreateOneTimePurchaseOrderResult;
  }) => void | Promise<void>;
  onError: (error: unknown) => void | Promise<void>;
}

interface IapCreateOneTimePurchaseOrderResult {
  orderId: string;
  displayName: string;
  displayAmount: string;
  amount: number;
  currency: string;
  fraction: number;
  miniAppIconUrl: string | null;
}
```

**响应**

在支付流程结束后调用以释放资源的 cleanup 函数（`() => void`）会被返回。

### 错误

错误代码可 `onError`作为……接收，或在包裹调用的 `try/catch`在其中捕获的错误的 `error.code` 值。

| 代码                                | 说明                                                                                                                            |
| --------------------------------- | ----------------------------------------------------------------------------------------------------------------------------- |
| `INVALID_PRODUCT_ID`              | 商品 ID 无效或商品不存在时。                                                                                                              |
| `PAYMENT_PENDING`                 | 支付仍在等待批准时。                                                                                                                    |
| `NETWORK_ERROR`                   | 因网络/服务器问题而无法处理请求时。                                                                                                            |
| `INVALID_USER_ENVIRONMENT`        | 在特定设备·账户·设置下无法购买该商品时。                                                                                                         |
| `ITEM_ALREADY_OWNED`              | 尝试再次购买已购买过的商品时。                                                                                                               |
| `APP_MARKET_VERIFICATION_FAILED`  | 已完成支付，但 App Store 验证失败时。                                                                                                      |
| `TOSS_SERVER_VERIFICATION_FAILED` | 已完成支付，但向服务器传送/保存失败时。                                                                                                          |
| `INTERNAL_ERROR`                  | 因服务器内部问题而无法处理请求时。                                                                                                             |
| `KOREAN_ACCOUNT_ONLY`             | 在 iOS 上不是韩国账号时。                                                                                                               |
| `USER_CANCELED`                   | 用户离开订单页时。                                                                                                                     |
| `PRODUCT_NOT_GRANTED_BY_PARTNER`  | 合作方商品发放失败时。                                                                                                                   |
| `UNSUPPORTED_APP_VERSION`         | 如果当前运行的 Toss App 版本不支持此功能，则调用后会立即发生。 `IAP.createOneTimePurchaseOrder.isSupported()`请先通过它确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { IAP } from "@apps-in-toss/web-framework";

const button = document.querySelector("#buy-button");
let cleanup;

button.addEventListener("click", () => {
  try {
    cleanup = IAP.createOneTimePurchaseOrder({
      options: {
        sku: "coin_100",
        processProductGrant: ({ orderId }) => {
          // 编写商品发放逻辑
          console.log("发放处理：", orderId);
          return true;
        },
      },
      onEvent: (event) => {
        console.log(event.type, event.data);
      },
      onError: (error) => {
        console.error(error);
      },
    });
  } catch (error) {
    console.error(error);
  }
});

// 离开页面时 cleanup?.()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.createonetimepurchaseorder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
